#ifndef __KEYTABLE_H_INCLUD
#define __KEYTABLE_H_INCLUDED__


#ifndef NR_KEYS
#define NR_KEYS 128
#endif /* ! NR_KEYS */


#ifndef NR_KEYCODES
#define NR_KEYCODES 128
#endif /* ! NR_KEYCODES */


#define MODIF_2ND 0x01
#define MODIF_CAPS 0x02
#define MODIF_NUM 0x03

#ifndef KEYCODE_IGN
#define KEYCODE_IGN 0
#endif

/* Guylhem: Fixed all that. Now tables are strictly identical and sharp
 * keycodes are identical to what they are on a normal PC.
 * See tosa_keymap.map for details on shap special keys codes and mappings.
 */


static unsigned char rawkeytable_table[(NR_KEYCODES+1)] = {
KEYCODE_IGN,		/* 1  */
KEYCODE_IGN,		/* 2  */
KEYCODE_W,		/* 3  */
KEYCODE_IGN,		/* 4  */
KEYCODE_IGN,		/* 5  */
KEYCODE_IGN,		/* 6  */
KEYCODE_K,		/* 7  */
KEYCODE_BACKSPACE,	/* 8  */
KEYCODE_P,		/* 9  */
KEYCODE_IGN,		/* 10  */
KEYCODE_IGN,		/* 11  */
KEYCODE_IGN,		/* 12  */
KEYCODE_F11,		/* 13 : Power */
KEYCODE_IGN,		/* 14  */
KEYCODE_IGN,		/* 15  */
KEYCODE_IGN,		/* 16  */
KEYCODE_IGN,		/* 17  */
KEYCODE_Q,		/* 18  */
KEYCODE_E,		/* 19  */
KEYCODE_T,		/* 20  */
KEYCODE_Y,		/* 21  */
KEYCODE_IGN,		/* 22  */
KEYCODE_O,		/* 23  */
KEYCODE_I,		/* 24  */
KEYCODE_DO,		/* 25 : ,;> */
KEYCODE_IGN,		/* 26  */
KEYCODE_IGN,		/* 27  */
KEYCODE_IGN,		/* 28  */
KEYCODE_F12,		/* 29 : Record */
KEYCODE_IGN,		/* 30  */
KEYCODE_IGN,		/* 31  */
KEYCODE_IGN,		/* 32  */
KEYCODE_IGN,		/* 33  */
KEYCODE_A,		/* 34  */
KEYCODE_D,		/* 35  */
KEYCODE_G,		/* 36  */
KEYCODE_U,		/* 37  */
KEYCODE_IGN,		/* 38  */
KEYCODE_L,		/* 39  */
KEYCODE_ENTER,		/* 40  */
KEYCODE_HELP,	/* 41 : .:< */
KEYCODE_IGN,		/* 42  */
KEYCODE_IGN,		/* 43  */
KEYCODE_IGN,		/* 44  */
KEYCODE_F10,		/* 45 : Sync */
KEYCODE_IGN,		/* 46  */
KEYCODE_IGN,		/* 47  */
KEYCODE_IGN,		/* 48  */
KEYCODE_IGN,		/* 49  */
KEYCODE_Z,		/* 50  */
KEYCODE_C,		/* 51  */
KEYCODE_V,		/* 52  */
KEYCODE_J,		/* 53  */
KEYCODE_F2,		/* 54 : Address */
KEYCODE_F8,		/* 55 : Cancel */
KEYCODE_STRANGE,	/* 56 : Select */
KEYCODE_F9,		/* 57 : Ok */
KEYCODE_LEFTSHIFT,	/* 58  */
KEYCODE_IGN,		/* 59  */
KEYCODE_IGN,		/* 60  */
KEYCODE_IGN,		/* 61  */
KEYCODE_IGN,		/* 62  */
KEYCODE_IGN,		/* 63  */
KEYCODE_IGN,		/* 64  */
KEYCODE_IGN,		/* 65  */
KEYCODE_S,		/* 66  */
KEYCODE_R,		/* 67  */
KEYCODE_B,		/* 68  */
KEYCODE_N,		/* 69  */
KEYCODE_F1,		/* 70 : Calendar  */
KEYCODE_F3,		/* 71 : Home */
KEYCODE_F6,		/* 72 : Userdef */
KEYCODE_F7,		/* 73 : Light */
KEYCODE_IGN,		/* 74  */
KEYCODE_RIGHTSHIFT,	/* 75  */
KEYCODE_IGN,		/* 76  */
KEYCODE_IGN,		/* 77  */
KEYCODE_IGN,		/* 78  */
KEYCODE_IGN,		/* 79  */
KEYCODE_IGN,		/* 80  */
KEYCODE_IGN,		/* 81  */
KEYCODE_MACRO,		/* 82 : Tab/Caps */
KEYCODE_F13,		/* 83 : /? */
KEYCODE_H,		/* 84  */
KEYCODE_M,		/* 85  */
KEYCODE_F4,		/* 86 : Menu */
KEYCODE_IGN,		/* 87  */
KEYCODE_KPCOMMA,	/* 88 : Up */
KEYCODE_IGN,		/* 89  */
KEYCODE_IGN,		/* 90  */
KEYCODE_IGN,		/* 91  */
KEYCODE_LEFTMETA,	/* 92 : Fn */
KEYCODE_IGN,		/* 93  */
KEYCODE_IGN,		/* 94  */
KEYCODE_IGN,		/* 95  */
KEYCODE_IGN,		/* 96  */
KEYCODE_IGN,		/* 97  */
KEYCODE_X,		/* 98  */
KEYCODE_F,		/* 99  */
KEYCODE_SPACE,		/* 100  */
KEYCODE_F14,		/* 101 : '" */
KEYCODE_F5,		/* 102 : Mail */
KEYCODE_HANGUEL,	/* 103 : Left */
KEYCODE_HANJA,		/* 104 : Down */
KEYCODE_YEN,		/* 105 : Right */
KEYCODE_IGN,		/* 106  */
KEYCODE_IGN,		/* 107  */
KEYCODE_IGN,		/* 108  */
KEYCODE_IGN,		/* 109  */
KEYCODE_IGN,		/* 110  */
KEYCODE_IGN,		/* 111  */
KEYCODE_IGN,		/* 112  */
KEYCODE_IGN,		/* 113  */
KEYCODE_IGN,		/* 114  */
KEYCODE_IGN,		/* 115  */
KEYCODE_IGN,		/* 116  */
KEYCODE_IGN,		/* 117  */
KEYCODE_IGN,		/* 118  */
KEYCODE_IGN,		/* 119  */
KEYCODE_IGN,		/* 120  */
KEYCODE_IGN,		/* 121  */
KEYCODE_IGN,		/* 122  */
KEYCODE_IGN,		/* 123  */
KEYCODE_IGN,		/* 124  */
KEYCODE_IGN,		/* 125  */
KEYCODE_IGN,		/* 126  */
KEYCODE_IGN,		/* 127  */
KEYCODE_IGN		/* 128  */
};


#define STATE_S0 0
#define STATE_S1 1
#define STATE_S2 2
#define STATE_S3 3
#define STATE_S4 4
#define STATE_S5 5
#define STATE_S6 6
#define STATE_S7 7
#define STATE_S8 8
#define STATE_S9 9
#define STATE_S10 10
#define STATE_S11 11
#define STATE_S12 12
#define STATE_S13 13
#define STATE_S14 14
#define STATE_S15 15
#define STATE_S16 16
#define STATE_S17 17
#define STATE_S18 18
#define STATE_S19 19
#define STATE_S20 20
#define STATE_S21 21
#define STATE_S22 22
#define STATE_S23 23
#define STATE_S24 24
#define STATE_S25 25
#define STATE_S26 26
#define STATE_S27 27
#define STATE_S28 28
#define STATE_S29 29
#define STATE_S30 30
#define STATE_S31 31
#define STATE_S32 32
#define STATE_S33 33
#define STATE_S34 34
#define STATE_S35 35
#define STATE_S36 36
#define STATE_S37 37
#define STATE_S38 38
#define STATE_S39 39
#define STATE_S40 40
#define STATE_S41 41
#define STATE_S42 42
#define STATE_S43 43
#define STATE_S44 44
#define STATE_S45 45
#define STATE_S46 46
#define STATE_S47 47
#define STATE_S48 48
#define STATE_S49 49
#define STATE_S50 50
#define STATE_S51 51
#define STATE_S52 52
#define STATE_S53 53
#define STATE_S54 54
#define STATE_S55 55
#define STATE_S56 56
#define STATE_S57 57
#define STATE_S58 58
#define STATE_S59 59
#define STATE_S60 60
#define STATE_S61 61
#define STATE_S62 62
#define STATE_S63 63
#define STATE_S64 64
#define STATE_S65 65
#define STATE_S66 66
#define STATE_S67 67
#define STATE_S68 68
#define STATE_S69 69
#define STATE_S70 70
#define STATE_S71 71
#define STATE_S72 72
#define STATE_S73 73
#define STATE_S74 74
#define STATE_S75 75
#define STATE_S76 76
#define STATE_S77 77
#define STATE_S78 78
#define STATE_S79 79


#define STATE_NUMS_TOTAL 80


#ifdef RAWKEY_MAP_DEBUG
static char *state_names[STATE_NUMS_TOTAL] = {
	"S0",
	"S1",
	"S2",
	"S3",
	"S4",
	"S5",
	"S6",
	"S7",
	"S8",
	"S9",
	"S10",
	"S11",
	"S12",
	"S13",
	"S14",
	"S15",
	"S16",
	"S17",
	"S18",
	"S19",
	"S20",
	"S21",
	"S22",
	"S23",
	"S24",
	"S25",
	"S26",
	"S27",
	"S28",
	"S29",
	"S30",
	"S31",
	"S32",
	"S33",
	"S34",
	"S35",
	"S36",
	"S37",
	"S38",
	"S39",
	"S40",
	"S41",
	"S42",
	"S43",
	"S44",
	"S45",
	"S46",
	"S47",
	"S48",
	"S49",
	"S50",
	"S51",
	"S52",
	"S53",
	"S54",
	"S55",
	"S56",
	"S57",
	"S58",
	"S59",
	"S60",
	"S61",
	"S62",
	"S63",
	"S64",
	"S65",
	"S66",
	"S67",
	"S68",
	"S69",
	"S70",
	"S71",
	"S72",
	"S73",
	"S74",
	"S75",
	"S76",
	"S77",
	"S78",
	"S79"
};
#endif /* RAWKEY_MAP_DEBUG */


static unsigned char state_table_LSHIFT_up[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S0,STATE_S2,STATE_S2,STATE_S4,STATE_S4,STATE_S6,STATE_S6,STATE_S8,STATE_S8,STATE_S10,STATE_S10,STATE_S12,STATE_S12,STATE_S14,STATE_S14,STATE_S16,STATE_S16,STATE_S18,STATE_S18,STATE_S20,STATE_S20,STATE_S22,STATE_S22,STATE_S24,STATE_S24,STATE_S26,STATE_S26,STATE_S28,STATE_S28,STATE_S30,STATE_S30,STATE_S32,STATE_S32,STATE_S34,STATE_S34,STATE_S36,STATE_S36,STATE_S38,STATE_S38,STATE_S40,STATE_S40,STATE_S42,STATE_S42,STATE_S44,STATE_S44,STATE_S46,STATE_S46,STATE_S48,STATE_S48,STATE_S50,STATE_S50,STATE_S52,STATE_S52,STATE_S54,STATE_S54,STATE_S56,STATE_S56,STATE_S58,STATE_S58,STATE_S60,STATE_S60,STATE_S62,STATE_S62,STATE_S64,STATE_S64,STATE_S66,STATE_S66,STATE_S68,STATE_S68,STATE_S70,STATE_S70,STATE_S72,STATE_S72,STATE_S74,STATE_S74,STATE_S76,STATE_S76,STATE_S78,STATE_S78};

static unsigned char state_table_RSHIFT_up[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S1,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S6,STATE_S7,STATE_S8,STATE_S9,STATE_S10,STATE_S11,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S16,STATE_S17,STATE_S18,STATE_S19,STATE_S20,STATE_S21,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S26,STATE_S27,STATE_S28,STATE_S29,STATE_S30,STATE_S31,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S36,STATE_S37,STATE_S38,STATE_S39,STATE_S0,STATE_S1,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S6,STATE_S7,STATE_S8,STATE_S9,STATE_S10,STATE_S11,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S16,STATE_S17,STATE_S18,STATE_S19,STATE_S20,STATE_S21,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S26,STATE_S27,STATE_S28,STATE_S29,STATE_S30,STATE_S31,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S36,STATE_S37,STATE_S38,STATE_S39};

static unsigned char state_table_2nd_up[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S1,STATE_S6,STATE_S7,STATE_S0,STATE_S1,STATE_S6,STATE_S7,STATE_S0,STATE_S1,STATE_S10,STATE_S11,STATE_S16,STATE_S17,STATE_S10,STATE_S11,STATE_S16,STATE_S17,STATE_S10,STATE_S11,STATE_S20,STATE_S21,STATE_S26,STATE_S27,STATE_S20,STATE_S21,STATE_S26,STATE_S27,STATE_S20,STATE_S21,STATE_S30,STATE_S31,STATE_S36,STATE_S37,STATE_S30,STATE_S31,STATE_S36,STATE_S37,STATE_S30,STATE_S31,STATE_S40,STATE_S41,STATE_S46,STATE_S47,STATE_S40,STATE_S41,STATE_S46,STATE_S47,STATE_S40,STATE_S41,STATE_S50,STATE_S51,STATE_S56,STATE_S57,STATE_S50,STATE_S51,STATE_S56,STATE_S57,STATE_S50,STATE_S51,STATE_S60,STATE_S61,STATE_S66,STATE_S67,STATE_S60,STATE_S61,STATE_S66,STATE_S67,STATE_S60,STATE_S61,STATE_S70,STATE_S71,STATE_S76,STATE_S77,STATE_S70,STATE_S71,STATE_S76,STATE_S77,STATE_S70,STATE_S71};



#define UP_TABLES_SIZE 3


static unsigned char *up_tables[UP_TABLES_SIZE] = {
	state_table_LSHIFT_up,state_table_RSHIFT_up,state_table_2nd_up
};


#define SEE_LSHIFT_UP 0
#define SEE_RSHIFT_UP 1
#define SEE_2nd_UP 2
#define UP_NOP -1


static char up_modifs_ref[(NR_KEYCODES+1)] = {
UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,SEE_LSHIFT_UP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,SEE_RSHIFT_UP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,SEE_2nd_UP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP,UP_NOP};


static unsigned char state_table_LSHIFT_down[STATE_NUMS_TOTAL] = {
STATE_S1,STATE_S1,STATE_S3,STATE_S3,STATE_S5,STATE_S5,STATE_S7,STATE_S7,STATE_S9,STATE_S9,STATE_S11,STATE_S11,STATE_S13,STATE_S13,STATE_S15,STATE_S15,STATE_S17,STATE_S17,STATE_S19,STATE_S19,STATE_S21,STATE_S21,STATE_S23,STATE_S23,STATE_S25,STATE_S25,STATE_S27,STATE_S27,STATE_S29,STATE_S29,STATE_S31,STATE_S31,STATE_S33,STATE_S33,STATE_S35,STATE_S35,STATE_S37,STATE_S37,STATE_S39,STATE_S39,STATE_S41,STATE_S41,STATE_S43,STATE_S43,STATE_S45,STATE_S45,STATE_S47,STATE_S47,STATE_S49,STATE_S49,STATE_S51,STATE_S51,STATE_S53,STATE_S53,STATE_S55,STATE_S55,STATE_S57,STATE_S57,STATE_S59,STATE_S59,STATE_S61,STATE_S61,STATE_S63,STATE_S63,STATE_S65,STATE_S65,STATE_S67,STATE_S67,STATE_S69,STATE_S69,STATE_S71,STATE_S71,STATE_S73,STATE_S73,STATE_S75,STATE_S75,STATE_S77,STATE_S77,STATE_S79,STATE_S79};

static unsigned char state_table_RSHIFT_down[STATE_NUMS_TOTAL] = {
STATE_S40,STATE_S41,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S46,STATE_S47,STATE_S48,STATE_S49,STATE_S50,STATE_S51,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S56,STATE_S57,STATE_S58,STATE_S59,STATE_S60,STATE_S61,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S66,STATE_S67,STATE_S68,STATE_S69,STATE_S70,STATE_S71,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S76,STATE_S77,STATE_S78,STATE_S79,STATE_S40,STATE_S41,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S46,STATE_S47,STATE_S48,STATE_S49,STATE_S50,STATE_S51,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S56,STATE_S57,STATE_S58,STATE_S59,STATE_S60,STATE_S61,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S66,STATE_S67,STATE_S68,STATE_S69,STATE_S70,STATE_S71,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S76,STATE_S77,STATE_S78,STATE_S79};

static unsigned char state_table_2nd_down[STATE_NUMS_TOTAL] = {
STATE_S2,STATE_S3,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S8,STATE_S9,STATE_S8,STATE_S9,STATE_S12,STATE_S13,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S18,STATE_S19,STATE_S18,STATE_S19,STATE_S22,STATE_S23,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S28,STATE_S29,STATE_S28,STATE_S29,STATE_S32,STATE_S33,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S38,STATE_S39,STATE_S38,STATE_S39,STATE_S42,STATE_S43,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S48,STATE_S49,STATE_S48,STATE_S49,STATE_S52,STATE_S53,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S58,STATE_S59,STATE_S58,STATE_S59,STATE_S62,STATE_S63,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S68,STATE_S69,STATE_S68,STATE_S69,STATE_S72,STATE_S73,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S78,STATE_S79,STATE_S78,STATE_S79};

static unsigned char state_table_caps_down[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S1,STATE_S14,STATE_S15,STATE_S14,STATE_S15,STATE_S10,STATE_S11,STATE_S14,STATE_S15,STATE_S10,STATE_S11,STATE_S4,STATE_S5,STATE_S4,STATE_S5,STATE_S0,STATE_S1,STATE_S4,STATE_S5,STATE_S20,STATE_S21,STATE_S34,STATE_S35,STATE_S34,STATE_S35,STATE_S30,STATE_S31,STATE_S34,STATE_S35,STATE_S30,STATE_S31,STATE_S24,STATE_S25,STATE_S24,STATE_S25,STATE_S20,STATE_S21,STATE_S24,STATE_S25,STATE_S40,STATE_S41,STATE_S54,STATE_S55,STATE_S54,STATE_S55,STATE_S50,STATE_S51,STATE_S54,STATE_S55,STATE_S50,STATE_S51,STATE_S44,STATE_S45,STATE_S44,STATE_S45,STATE_S40,STATE_S41,STATE_S44,STATE_S45,STATE_S60,STATE_S61,STATE_S74,STATE_S75,STATE_S74,STATE_S75,STATE_S70,STATE_S71,STATE_S74,STATE_S75,STATE_S70,STATE_S71,STATE_S64,STATE_S65,STATE_S64,STATE_S65,STATE_S60,STATE_S61,STATE_S64,STATE_S65};

static unsigned char state_table_num_down[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S1,STATE_S24,STATE_S25,STATE_S24,STATE_S25,STATE_S20,STATE_S21,STATE_S24,STATE_S25,STATE_S10,STATE_S11,STATE_S34,STATE_S35,STATE_S34,STATE_S35,STATE_S30,STATE_S31,STATE_S34,STATE_S35,STATE_S20,STATE_S21,STATE_S4,STATE_S5,STATE_S4,STATE_S5,STATE_S0,STATE_S1,STATE_S4,STATE_S5,STATE_S30,STATE_S31,STATE_S14,STATE_S15,STATE_S14,STATE_S15,STATE_S10,STATE_S11,STATE_S14,STATE_S15,STATE_S40,STATE_S41,STATE_S64,STATE_S65,STATE_S64,STATE_S65,STATE_S60,STATE_S61,STATE_S64,STATE_S65,STATE_S50,STATE_S51,STATE_S74,STATE_S75,STATE_S74,STATE_S75,STATE_S70,STATE_S71,STATE_S74,STATE_S75,STATE_S60,STATE_S61,STATE_S44,STATE_S45,STATE_S44,STATE_S45,STATE_S40,STATE_S41,STATE_S44,STATE_S45,STATE_S70,STATE_S71,STATE_S54,STATE_S55,STATE_S54,STATE_S55,STATE_S50,STATE_S51,STATE_S54,STATE_S55};

static unsigned char state_table_ANY_OTHER_down[STATE_NUMS_TOTAL] = {
STATE_S0,STATE_S1,STATE_S4,STATE_S5,STATE_S4,STATE_S5,STATE_S0,STATE_S1,STATE_S4,STATE_S5,STATE_S10,STATE_S11,STATE_S14,STATE_S15,STATE_S14,STATE_S15,STATE_S10,STATE_S11,STATE_S14,STATE_S15,STATE_S20,STATE_S21,STATE_S24,STATE_S25,STATE_S24,STATE_S25,STATE_S20,STATE_S21,STATE_S24,STATE_S25,STATE_S30,STATE_S31,STATE_S34,STATE_S35,STATE_S34,STATE_S35,STATE_S30,STATE_S31,STATE_S34,STATE_S35,STATE_S40,STATE_S41,STATE_S44,STATE_S45,STATE_S44,STATE_S45,STATE_S40,STATE_S41,STATE_S44,STATE_S45,STATE_S50,STATE_S51,STATE_S54,STATE_S55,STATE_S54,STATE_S55,STATE_S50,STATE_S51,STATE_S54,STATE_S55,STATE_S60,STATE_S61,STATE_S64,STATE_S65,STATE_S64,STATE_S65,STATE_S60,STATE_S61,STATE_S64,STATE_S65,STATE_S70,STATE_S71,STATE_S74,STATE_S75,STATE_S74,STATE_S75,STATE_S70,STATE_S71,STATE_S74,STATE_S75};



#define DOWN_TABLES_SIZE 6


static unsigned char *down_tables[DOWN_TABLES_SIZE] = {
	state_table_LSHIFT_down,state_table_RSHIFT_down,state_table_2nd_down,state_table_caps_down,state_table_num_down,state_table_ANY_OTHER_down
};


#define SEE_LSHIFT_DOWN 0
#define SEE_RSHIFT_DOWN 1
#define SEE_2nd_DOWN 2
#define SEE_caps_DOWN 3
#define SEE_num_DOWN 4
#define SEE_ANY_OTHER_DOWN 5
#define DOWN_NOP -1


static char down_modifs_ref[(NR_KEYCODES+1)] = {
DOWN_NOP,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_LSHIFT_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_RSHIFT_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_2nd_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_caps_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_num_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN,SEE_ANY_OTHER_DOWN};


static unsigned char extmodif_map_2nd[STATE_NUMS_TOTAL] = {0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1};
static unsigned char extmodif_map_CAPS[STATE_NUMS_TOTAL] = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1};
static unsigned char extmodif_map_NUM[STATE_NUMS_TOTAL] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

#define EXTMODIF_SHOWSTAT_KEYMAX 4

static unsigned char *extmodif_status_tables[EXTMODIF_SHOWSTAT_KEYMAX] = {
NULL,extmodif_map_2nd,extmodif_map_CAPS,extmodif_map_NUM};


static unsigned char extmove_map_2nd[STATE_NUMS_TOTAL] = {STATE_S6,STATE_S7,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S0,STATE_S1,STATE_S8,STATE_S9,STATE_S16,STATE_S17,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S10,STATE_S11,STATE_S18,STATE_S19,STATE_S26,STATE_S27,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S20,STATE_S21,STATE_S28,STATE_S29,STATE_S36,STATE_S37,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S30,STATE_S31,STATE_S38,STATE_S39,STATE_S46,STATE_S47,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S40,STATE_S41,STATE_S48,STATE_S49,STATE_S56,STATE_S57,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S50,STATE_S51,STATE_S58,STATE_S59,STATE_S66,STATE_S67,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S60,STATE_S61,STATE_S68,STATE_S69,STATE_S76,STATE_S77,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S70,STATE_S71,STATE_S78,STATE_S79};
static unsigned char extmove_map_CAPS[STATE_NUMS_TOTAL] = {STATE_S10,STATE_S11,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S16,STATE_S17,STATE_S18,STATE_S19,STATE_S0,STATE_S1,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S6,STATE_S7,STATE_S8,STATE_S9,STATE_S30,STATE_S31,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S36,STATE_S37,STATE_S38,STATE_S39,STATE_S20,STATE_S21,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S26,STATE_S27,STATE_S28,STATE_S29,STATE_S50,STATE_S51,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S56,STATE_S57,STATE_S58,STATE_S59,STATE_S40,STATE_S41,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S46,STATE_S47,STATE_S48,STATE_S49,STATE_S70,STATE_S71,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S76,STATE_S77,STATE_S78,STATE_S79,STATE_S60,STATE_S61,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S66,STATE_S67,STATE_S68,STATE_S69};
static unsigned char extmove_map_NUM[STATE_NUMS_TOTAL] = {STATE_S20,STATE_S21,STATE_S22,STATE_S23,STATE_S24,STATE_S25,STATE_S26,STATE_S27,STATE_S28,STATE_S29,STATE_S30,STATE_S31,STATE_S32,STATE_S33,STATE_S34,STATE_S35,STATE_S36,STATE_S37,STATE_S38,STATE_S39,STATE_S0,STATE_S1,STATE_S2,STATE_S3,STATE_S4,STATE_S5,STATE_S6,STATE_S7,STATE_S8,STATE_S9,STATE_S10,STATE_S11,STATE_S12,STATE_S13,STATE_S14,STATE_S15,STATE_S16,STATE_S17,STATE_S18,STATE_S19,STATE_S60,STATE_S61,STATE_S62,STATE_S63,STATE_S64,STATE_S65,STATE_S66,STATE_S67,STATE_S68,STATE_S69,STATE_S70,STATE_S71,STATE_S72,STATE_S73,STATE_S74,STATE_S75,STATE_S76,STATE_S77,STATE_S78,STATE_S79,STATE_S40,STATE_S41,STATE_S42,STATE_S43,STATE_S44,STATE_S45,STATE_S46,STATE_S47,STATE_S48,STATE_S49,STATE_S50,STATE_S51,STATE_S52,STATE_S53,STATE_S54,STATE_S55,STATE_S56,STATE_S57,STATE_S58,STATE_S59};

#define EXTMODIF_MOVESTAT_KEYMAX 4

static unsigned char *extmodif_move_tables[EXTMODIF_MOVESTAT_KEYMAX] = {
NULL,extmove_map_2nd,extmove_map_CAPS,extmove_map_NUM};



typedef struct shappda_holdkey_info {
	int type;
	int character;
	void (*func)(void);
} shappda_holdkey_info;

#define HOLDKEYTYPE_CHAR 1
#define HOLDKEYTYPE_FUNC 2

/* Guylhem: new hold keys, to add dual function to each key.
 *
 * Syntax: #raw keycode = zaurus key = keypmap code for hold
 *
 * Hard keys go first
 */

// #45 = sync = 101
static shappda_holdkey_info shappda_holdkey_Sync = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_BREAK,
	func: NULL
};
// #13 = power =  119
static shappda_holdkey_info shappda_holdkey_Power = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_PAUSE,
	func: NULL
 };

// #29 = record = 99
static shappda_holdkey_info shappda_holdkey_Record = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_PRINTSCREEN,
	func: NULL
};
// #70 = calendar = 89
static shappda_holdkey_info shappda_holdkey_Calendar = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_RO,
	func: NULL
};
// #54 = address = 90
static shappda_holdkey_info shappda_holdkey_Address = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_KATAKANA,
	func: NULL
};
// #71 = home = 91
static shappda_holdkey_info shappda_holdkey_Home = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_HIRAGANA,
	func: NULL
};
// #86 = menu = 92
static shappda_holdkey_info shappda_holdkey_Menu = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_HENKAN,
	func: NULL
};
// #102 = mail = 93
static shappda_holdkey_info shappda_holdkey_Mail = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_KATAKANAHIRAGANA,
	func: NULL
};
// #72 = userdef = 94
static shappda_holdkey_info shappda_holdkey_UserDef = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_MUHENKAN,
	func: NULL
};
// #73 = light = 95
static shappda_holdkey_info shappda_holdkey_Light = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_KPJPCOMM,
	func: NULL
};
// #55 = cancel = 102
static shappda_holdkey_info shappda_holdkey_Cancel = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_HOME,
	func: NULL
};
// #57 = ok = 107
static shappda_holdkey_info shappda_holdkey_Ok = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_END,
	func: NULL
};
// #56 = select = 110
static shappda_holdkey_info shappda_holdkey_Select = {
	type: HOLDKEYTYPE_CHAR,
	character: KEYCODE_INSERT,
	func: NULL
};

static shappda_holdkey_info *holdkey_info[(NR_KEYCODES+1)] = {
NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Power, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Record, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Sync, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Address, &shappda_holdkey_Cancel, &shappda_holdkey_Select, &shappda_holdkey_Ok, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Calendar, &shappda_holdkey_Home, &shappda_holdkey_UserDef, &shappda_holdkey_Light, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Menu, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &shappda_holdkey_Mail, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};


static unsigned char *state_to_keymap[STATE_NUMS_TOTAL] = {
rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table,rawkeytable_table};


#endif /* ! __KEYTABLE_H_INCLUDED__ */
