/*
 *  linux/drivers/mmc/samcop_mmc.h - SAMCOP SDI Interface driver
 *
 *  Copyright (C) 2004 Thomas Kleffel, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

struct clk;

//FIXME: DMA Resource management ?!
// Is this the DMA channel to use?
#define SAMCOP_SDI_DMA 0

#define SAMCOP_SDI_ASIC_SAMCOP 0
#define SAMCOP_SDI_ASIC_HAMCOP 1

enum samcop_sdi_waitfor {
	COMPLETION_NONE,
	COMPLETION_CMDSENT,
	COMPLETION_RSPFIN,
	COMPLETION_XFERFINISH,
	COMPLETION_XFERFINISH_RSPFIN,
};

struct samcop_sdi_host {
	struct device		*parent;
	struct soc_device	*sdev;
	int			asic_type;
	struct mmc_host		*mmc;

	struct resource		*mem;
	struct clk		*clk;
	void __iomem		*base;
	int			irq;
	int			irq_cd;
	int			dma;
	
	struct mmc_request	*mrq;

	spinlock_t		complete_lock;
	struct completion	complete_request;
	struct completion	complete_dma;
	enum samcop_sdi_waitfor	complete_what;
};
