/*
 *  sharp_keycode.h
 *
 *  Raw Keycode Definitions for SHARP PDA
 *
 *  Copyright (C) 2001 SHARP
 *
 * Change Log:
 * 	12-Dec-2002 Sharp Corporation
 */

#ifndef __SHARP_KEYCODE_H_INCLUDED
#define __SHARP_KEYCODE_H_INCLUDED

#ifndef CONFIG_ARCH_PXA_TOSA_NEWKBD
// Go with broken Sharp "standard"

#define SLKEYCODE_VERSION       3

#define	SLKEY_A			1
#define	SLKEY_B			2
#define	SLKEY_C			3
#define	SLKEY_D			4
#define	SLKEY_E			5
#define	SLKEY_F			6
#define	SLKEY_G			7
#define	SLKEY_H			8
#define	SLKEY_I			9
#define	SLKEY_J			10
#define	SLKEY_K			11
#define	SLKEY_L			12
#define	SLKEY_M			13
#define	SLKEY_N			14
#define	SLKEY_O			15
#define	SLKEY_P			16
#define	SLKEY_Q			17
#define	SLKEY_R			18
#define	SLKEY_S			19
#define	SLKEY_T			20
#define	SLKEY_U			21
#define	SLKEY_V			22
#define	SLKEY_W			23
#define	SLKEY_X			24
#define	SLKEY_Y			25
#define	SLKEY_Z			26
#define	SLKEY_LSHIFT		27
#define	SLKEY_SHIFT		(SLKEY_LSHIFT)  /* alias for SLKEY_LSHIFT */
#define	SLKEY_ENTER		28
#define	SLKEY_F2		29
#define	SLKEY_2ND		30 /* SLKEY_F12 on Ver.1 */
#define	SLKEY_BACK_SPACE	31
#define	SLKEY_SYM		32 /* SLKEY_F3 on Ver.1 */
#define	SLKEY_FRONTLIGHT	33 /* SLKEY_F1 on Ver.1 */
#define	SLKEY_F9		34 /* SLKEY_CANCEL on Ver.1 */
#define	SLKEY_LEFT		35
#define	SLKEY_UP		36
#define	SLKEY_DOWN		37
#define	SLKEY_RIGHT		38
#define	SLKEY_F4		39
#define	SLKEY_HOME		40
#define	SLKEY_1			41
#define	SLKEY_2			42
#define	SLKEY_3			43
#define	SLKEY_4			44
#define	SLKEY_5			45
#define	SLKEY_6			46
#define	SLKEY_7			47
#define	SLKEY_8			48
#define	SLKEY_9			49
#define	SLKEY_0			50
#define	SLKEY_a_DIAERESIS	51
#define	SLKEY_u_DIAERESIS	52
#define	SLKEY_o_DIAERESIS	53
#define	SLKEY_A_DIAERESIS	54
#define	SLKEY_U_DIAERESIS	55
#define	SLKEY_O_DIAERESIS	56
#define	SLKEY_SSHARP		57
#define	SLKEY_MINUS		58
#define	SLKEY_PLUS		59
#define	SLKEY_CAPS_LOCK		60
#define	SLKEY_AT		61
#define	SLKEY_QUESTION		62
#define	SLKEY_COMMA		63
#define	SLKEY_PERIOD		64
#define	SLKEY_TAB		65
#define	SLKEY_F5		66
#define	SLKEY_F6		67
#define	SLKEY_F7		68
#define	SLKEY_SLASH		69
#define	SLKEY_APOSTROPHE	70
#define	SLKEY_SEMICOLON		71
#define	SLKEY_QUOTEDBL		72
#define	SLKEY_COLON		73
#define	SLKEY_NUMBERSIGN	74
#define	SLKEY_DOLLAR		75
#define	SLKEY_PERCENT		76
/* #define	SLKEY_ASCIICIRCUM	77 */
#define SLKEY_UNDERSCORE	77
#define	SLKEY_AMPERSAND		78
#define	SLKEY_ASTERISK		79
#define	SLKEY_PARENLEFT		80
#define	SLKEY_DELETE		81
#define	SLKEY_F10		82 /* SLKEY_END on Ver.1 */
#define	SLKEY_EQUAL		83
#define	SLKEY_PARENRIGHT	84
#define	SLKEY_ASCIITILDE	85
#define	SLKEY_LESS		86
#define	SLKEY_GREATER		87
#define	SLKEY_ACTIVITY		88 /* SLKEY_F8 on Ver.1 */
#define	SLKEY_CONTACTS		89 /* SLKEY_F9 on Ver.1 */
#define	SLKEY_MAIL		90 /* SLKEY_F10 on Ver.1 */
#define	SLKEY_F11		91
#define SLKEY_SPACE             92
#define SLKEY_PHONE             93
#define SLKEY_EXCLAM            94

#define	SLKEY_RSHIFT		103
#define SLKEY_LCONTROL          104
#define SLKEY_CONTROL           (SLKEY_LCONTROL) /* alias for SLKEY_LCONTROL */
#define SLKEY_RCONTROL          105
#define SLKEY_LALT              106
#define SLKEY_ALT               (SLKEY_LALT)  /* alias for SLKEY_LALT */
#define SLKEY_RALT              107
#define SLKEY_ALTGRAPH          108

#define SLKEY_OFF               109
#define SLKEY_MAIL2             110
#define SLKEY_SCREEN            111
#define SLKEY_NUMLOCK           112
#define SLKEY_PAGEUP            113
#define SLKEY_PAGEDOWN          114

#define SLKEY_PRINTSCREEN       115
#define	SLKEY_ASCIICIRCUM	116
#define SLKEY_SYNCSTART		117
#define SLKEY_CARKIT		118
#define SLKEY_REMOCON		119

#define SLKEY_RECORDER		120

// for C3
#define SLKEY_KANA		121
#define SLKEY_ZENHAN		122
#define SLKEY_EXSELECT		123
#define SLKEY_EXCANCEL		124
#define SLKEY_EXJOGUP		125
#define SLKEY_EXJOGDOWN		126

#define SLKEY_RCREL		95
#define SLKEY_RCVOLUP		96
#define SLKEY_RCVOLDWN		97
#define SLKEY_RCFF		98
#define SLKEY_RCREW		99
#define SLKEY_RCSTP		100
#define SLKEY_RCPLY		101

#define SLKEY_HINGEMOVED	102

/* these are not used on Ver.2 */
//#define	SLKEY_CONVERT		95
//#define	SLKEY_NONCONVERT	96
//#define	SLKEY_KANJI		97
//#define	SLKEY_KANA		98
//#define	SLKEY_ACCEPT		99
//#define	SLKEY_MODECHANGE	100
//#define	SLKEY_FINAL		101
//#define	SLKEY_PRINTSCREEN	102
//
#else /* CONFIG_ARCH_PXA_TOSA_NEWKBD = y */

#define SLKEYCODE_VERSION       4

/* Guylhem : assign standard keycodes */

/* Attention, the following keycodes have a special meaning.
 * They are used within the kernel, so an alias was defined:
 *
KEYCODE_FRONTLIGHT
KEYCODE_OFF
KEYCODE_HINGEMOVED
KEYCODE_SYNCSTART
 *
 * The following are used directly in drivers/char/sharp_kbdctl.c:
 *
KEYCODE_LEFTMETA
KEYCODE_CAPSLOCK
KEYCODE_NUMLOCK
 *
 * If you need empty keycodes, ie. keycodes that can not be generated
 * from a standard 105 keys PC Keyboard, pick them up from KEYCODE_EMPTY_
 * which duplicates definitions are here to help you find empty keycodes
 */

#define	KEYCODE_ESC		1
#define	KEYCODE_1		2
#define	KEYCODE_2		3
#define	KEYCODE_3		4
#define	KEYCODE_4		5
#define	KEYCODE_5		6
#define	KEYCODE_6		7
#define	KEYCODE_7		8
#define	KEYCODE_8		9
#define	KEYCODE_9		10
#define	KEYCODE_0		11
#define	KEYCODE_MINUS		12
#define	KEYCODE_EQUAL		13
#define	KEYCODE_BACKSPACE	14
#define	KEYCODE_TAB		15
#define	KEYCODE_Q		16
#define	KEYCODE_W		17
#define	KEYCODE_E		18
#define	KEYCODE_R		19
#define	KEYCODE_T		20
#define	KEYCODE_Y		21
#define	KEYCODE_U		22
#define	KEYCODE_I		23
#define	KEYCODE_O		24
#define	KEYCODE_P		25
#define	KEYCODE_LEFTBRACE	26
#define	KEYCODE_RIGHTBRACE	27
#define	KEYCODE_ENTER		28
#define	KEYCODE_LEFTCTRL	29
#define	KEYCODE_A		30
#define	KEYCODE_S		31
#define	KEYCODE_D		32
#define	KEYCODE_F		33
#define	KEYCODE_G		34
#define	KEYCODE_H		35
#define	KEYCODE_J		36
#define	KEYCODE_K		37
#define	KEYCODE_L		38
#define	KEYCODE_SEMICOLON	39
#define	KEYCODE_APOSTROPHE	40
#define	KEYCODE_GRAVE		41
#define	KEYCODE_LEFTSHIFT	42
#define	KEYCODE_BACKSLASH	43
#define	KEYCODE_Z		44
#define	KEYCODE_X		45
#define	KEYCODE_C		46
#define	KEYCODE_V		47
#define	KEYCODE_B		48
#define	KEYCODE_N		49
#define	KEYCODE_M		50
#define	KEYCODE_COMMA		51
#define	KEYCODE_DOT		52
#define	KEYCODE_SLASH		53
#define	KEYCODE_RIGHTSHIFT	54
#define	KEYCODE_KPASTERISK	55
#define	KEYCODE_LEFTALT		56
#define	KEYCODE_SPACE		57
#define	KEYCODE_CAPSLOCK	58
#define	KEYCODE_F1		59
#define	KEYCODE_F2		60
#define	KEYCODE_F3		61
#define	KEYCODE_F4		62
#define	KEYCODE_F5		63
#define	KEYCODE_F6		64
#define	KEYCODE_F7		65
#define	KEYCODE_F8		66
#define	KEYCODE_F9		67
#define	KEYCODE_F10		68
#define	KEYCODE_NUMLOCK		69
#define	KEYCODE_SCROLLLOCK	70
#define	KEYCODE_KP7		71
#define	KEYCODE_KP8		72
#define	KEYCODE_KP9		73
#define	KEYCODE_KPMINUS		74
#define	KEYCODE_KP4		75
#define	KEYCODE_KP5		76
#define	KEYCODE_KP6		77
#define	KEYCODE_KPPLUS		78
#define	KEYCODE_KP1		79
#define	KEYCODE_KP2		80
#define	KEYCODE_KP3		81
#define	KEYCODE_KP0		82
#define	KEYCODE_KPDOT		83
#define	KEYCODE_SYSREQ		84
#define	KEYCODE_ZENKAKUHANKAKU	85
#define	KEYCODE_102ND		86
#define	KEYCODE_F11		87
#define	KEYCODE_F12		88
#define	KEYCODE_RO		89
#define	KEYCODE_KATAKANA	90
#define	KEYCODE_HIRAGANA	91
#define	KEYCODE_HENKAN		92
#define	KEYCODE_KATAKANAHIRAGANA	93
#define	KEYCODE_MUHENKAN	94
#define	KEYCODE_KPJPCOMM	95
#define	KEYCODE_KPENTER		96
#define	KEYCODE_RIGHTCTRL	97
#define	KEYCODE_KPSLASH		98
#define	KEYCODE_PRINTSCREEN	99
#define	KEYCODE_RIGHTALT	100
#define	KEYCODE_BREAK		101
#define	KEYCODE_HOME		102
#define	KEYCODE_UP		103
#define	KEYCODE_PAGEUP		104
#define	KEYCODE_LEFT		105
#define	KEYCODE_RIGHT		106
#define	KEYCODE_END		107
#define	KEYCODE_DOWN		108
#define	KEYCODE_PAGEDOWN	109
#define	KEYCODE_INSERT		110
#define	KEYCODE_DELETE		111
#define	KEYCODE_MACRO		112
#define	KEYCODE_F13		113
#define	KEYCODE_F14		114
#define	KEYCODE_HELP		115
#define	KEYCODE_DO		116
#define	KEYCODE_KPEQUAL		117
#define	KEYCODE_KPPLUSMINUS	118
#define	KEYCODE_PAUSE		119
#define	KEYCODE_STRANGE		120
#define	KEYCODE_KPCOMMA		121
#define	KEYCODE_HANGUEL		122
#define	KEYCODE_HANJA		123
#define	KEYCODE_YEN		124
#define	KEYCODE_LEFTMETA	125
#define	KEYCODE_RIGHTMETA	126
#define	KEYCODE_COMPOSE		127
#define	KEYCODE_STOP		128


/* Aliases for the kernel */
#define KEYCODE_FRONTLIGHT KEYCODE_F7
#define KEYCODE_OFF KEYCODE_PAUSE
#define KEYCODE_HINGEMOVED KEYCODE_SCROLLLOCK
#define KEYCODE_SYNCSTART KEYCODE_F10

/* The following "empty" keycode are used by newkb:
85
86
89 // Calendar held
90 // Address held
91 // Home held
92 // Menu held
93 // Mail held
94 // User held
95 // Light held
112 // Tabs/Cap
113 // /?
114 // '"
115 // ,>;
116 // .<:
117
118
120 // Select
121 // Up
122 // Left
123 // Down
124 // Right
*/

#ifdef CONFIG_ARCH_PXA_TOSA_NEWKBD_OLDQT
/* Compatibility mode : Swap
Z_Bigspace/120			Z_Record_Held/99
Z_Record/88			Z_Calendar/59
Z_Calendar/59			Z_Bigspace/120
Z_Calendar_Held/89		Z_Address/60
Z_Record_Held/99		Z_Record/88
apostrophe/40			Z_Home/61
control/29			Z_Menu/62
Z_Address/90			Z_Mail/63
Caps_Lock/58			Z_User/64
f/33				Z_Light/65
a/30				Z_Fn/125
*/

#undef	KEYCODE_LEFTCTRL
#define	KEYCODE_LEFTCTRL	62
#undef	KEYCODE_A
#define	KEYCODE_A		125
#undef	KEYCODE_F
#define	KEYCODE_F		65
#undef	KEYCODE_APOSTROPHE
#define	KEYCODE_APOSTROPHE	61
#undef	KEYCODE_CAPSLOCK
#define	KEYCODE_CAPSLOCK	64
#undef	KEYCODE_F1
#define	KEYCODE_F1		88	// Calendar
#undef	KEYCODE_F2
#define	KEYCODE_F2		89	// Address
#undef	KEYCODE_F3
#define	KEYCODE_F3		40	// Home
#undef	KEYCODE_F4
#define	KEYCODE_F4		29	// Menu
#undef	KEYCODE_F5
#define	KEYCODE_F5		90	// Mail
#undef	KEYCODE_F6
#define	KEYCODE_F6		58	// User
#undef	KEYCODE_F7
#define	KEYCODE_F7		33	// Light
#undef	KEYCODE_F12
#define	KEYCODE_F12		99	// Record
#undef	KEYCODE_RO
#define	KEYCODE_RO		60	// Address held
#undef	KEYCODE_KATAKANA
#define	KEYCODE_KATAKANA	63	// Calendar held
#undef	KEYCODE_STRANGE
#define	KEYCODE_STRANGE		59	// Bigspace
#undef	KEYCODE_LEFTMETA
#define	KEYCODE_LEFTMETA	30	// Fn
#undef	KEYCODE_PRINTSCREEN
#define	KEYCODE_PRINTSCREEN	120	// Record held
#endif /* CONFIG_ARCH_PXA_TOSA_NEWKBD_OLDQT */
#endif /* CONFIG_ARCH_PXA_TOSA_NEWKBD */

#endif /* __SHARP_KEYCODE_H_INCLUDED */
